import { SetStateAction } from 'react';
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useArray | useArray} hook.
 */
export declare const useArray: <T>(initial?: T[]) => {
    array: T[];
    length: number;
    get(index: number): T | undefined;
    set(index: number, element: T): void;
    has(...elements: T[]): boolean;
    count(element: T): number;
    push(...elements: T[]): void;
    pop(index?: number): T | undefined;
    shift(): T | undefined;
    unshift(...elements: T[]): void;
    insert(index: number, ...elements: T[]): void;
    reset(value?: SetStateAction<T[]>): void;
};
