/// <reference types="react" />
export type MediaSourceObject = HTMLAudioElement | HTMLVideoElement | MediaStream;
export type MediaSourceNode<T extends MediaSourceObject> = T extends MediaStream ? MediaElementAudioSourceNode : MediaStreamAudioSourceNode;
export type FrequencyDataHandler = (data: Uint8Array) => any;
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useAudioAnalyser | useAudioAnalyser} hook.
 */
export declare const useAudioAnalyser: (args: {
    handler: FrequencyDataHandler;
    fftSize?: number;
}) => {
    nodeRef: import("react").MutableRefObject<AnalyserNode | undefined>;
    context: import("react").MutableRefObject<AudioContext | undefined>;
    connect: <T extends MediaSourceObject>(source: T) => Promise<MediaSourceNode<T> | undefined>;
    disconnect: () => void;
};
