"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBoolean = void 0;
const react_1 = require("react");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useBoolean | useBoolean} hook.
 */
const useBoolean = (initial = false) => {
    const [value, setValue] = (0, react_1.useState)(initial);
    const toggle = (0, react_1.useCallback)((value) => {
        setValue(value === undefined ? prev => !prev : value);
    }, [value]);
    return [value, toggle];
};
exports.useBoolean = useBoolean;
//# sourceMappingURL=index.js.map