"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useClickAway = void 0;
const react_1 = require("react");
const useEventListener_1 = require("../useEventListener");
const useNewRef_1 = require("../utils/useNewRef");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useClickAway | useClickAway} hook.
 */
const useClickAway = (args) => {
    const targetRef = (0, useNewRef_1.useNewRef)(args.ref);
    const handleClick = (0, react_1.useCallback)((event) => {
        const element = targetRef.current;
        element && !element.contains(event.target) && args.handler(event);
    }, [args.handler]);
    (0, useEventListener_1.useEventListener)({
        event: 'click',
        handler: handleClick,
        target: () => document
    });
    return targetRef;
};
exports.useClickAway = useClickAway;
//# sourceMappingURL=index.js.map