"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useClock = void 0;
const react_1 = require("react");
const useInterval_1 = require("../useInterval");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useClock | useClock} hook.
 */
const useClock = (args = {}) => {
    const [clock, setClock] = (0, react_1.useState)(new Date());
    (0, useInterval_1.useInterval)({
        callback: () => setClock(new Date()),
        timeout: Math.abs(Math.floor(args.timeout ?? 1000)),
        startOnMount: true
    });
    return clock;
};
exports.useClock = useClock;
//# sourceMappingURL=index.js.map