"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDebouncedState = void 0;
const react_1 = require("react");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useDebouncedState | useDebouncedState} hook.
 */
const useDebouncedState = (args) => {
    const [value, setValue] = (0, react_1.useState)(args.initial);
    const [debouncedValue, setDebouncedValue] = (0, react_1.useState)(args.initial);
    (0, react_1.useEffect)(() => {
        setValue(args.initial);
    }, [args.initial]);
    (0, react_1.useEffect)(() => {
        const timeout = setTimeout(() => setDebouncedValue(value), args.delay);
        return () => clearTimeout(timeout);
    }, [value]);
    return [debouncedValue, setValue, value];
};
exports.useDebouncedState = useDebouncedState;
//# sourceMappingURL=index.js.map