/// <reference types="react" />
export type DragAction = {
    type: 'start' | 'moving' | 'end';
    clientX: number;
    clientY: number;
    initialX: number;
    initialY: number;
    target: EventTarget;
    event: PointerEvent;
};
export type DragActionHandler = (action: DragAction) => any;
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useDragAndDrop | useDragAndDrop} hook.
 */
export declare const useDragAndDrop: <T extends HTMLElement = HTMLDivElement>(args: {
    handler: DragActionHandler;
    ref?: React.RefObject<T> | null;
}) => import("react").RefObject<T>;
