type EventMap<T extends EventTarget> = T extends Window ? WindowEventMap : T extends Document ? DocumentEventMap : T extends HTMLElement ? HTMLElementEventMap : GlobalEventHandlersEventMap;
type EventHandler<T extends EventTarget, E extends keyof EventMap<T>> = (event: EventMap<T>[E]) => any;
type Falsy = false | null | undefined;
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useEventListener | useEventListener} hook.
 */
export declare const useEventListener: <T extends EventTarget, E extends keyof EventMap<T> & string>(args: AddEventListenerOptions & {
    event: E | Array<E | Falsy>;
    handler: EventHandler<T, E>;
    ref?: React.RefObject<T>;
    target?: () => T | Falsy;
}) => void;
export {};
