"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useEventListener = void 0;
const react_1 = require("react");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useEventListener | useEventListener} hook.
 */
const useEventListener = (args) => {
    (0, react_1.useEffect)(() => {
        if (!args.ref && !args.target)
            return;
        const element = args.ref?.current ?? args.target?.();
        if (!element)
            return;
        const resolvedEvents = Array.isArray(args.event)
            ? args.event.filter(Boolean)
            : [args.event];
        resolvedEvents.forEach(e => element.addEventListener(e, args.handler, args));
        return () => {
            resolvedEvents.forEach(e => element.removeEventListener(e, args.handler, args));
        };
    }, [args.handler]);
};
exports.useEventListener = useEventListener;
//# sourceMappingURL=index.js.map