"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useGeolocation = void 0;
const react_1 = require("react");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useGeolocation | useGeolocation} hook.
 */
const useGeolocation = (options = {}) => {
    const [state, setState] = (0, react_1.useState)({ isLoading: true });
    const successCallback = (0, react_1.useCallback)(({ coords, timestamp }) => {
        setState({
            isLoading: false,
            latitude: coords.latitude,
            longitude: coords.longitude,
            altitude: coords.altitude,
            accuracy: coords.accuracy,
            altitudeAccuracy: coords.altitudeAccuracy,
            heading: coords.heading,
            speed: coords.speed,
            timestamp
        });
    }, []);
    const errorCallback = (0, react_1.useCallback)(error => {
        setState(state => ({ ...state, loading: false, error }));
    }, []);
    (0, react_1.useEffect)(() => {
        navigator.geolocation.getCurrentPosition(successCallback, errorCallback, options);
        const watch = navigator.geolocation.watchPosition(successCallback, errorCallback, options);
        return () => navigator.geolocation.clearWatch(watch);
    }, []);
    return state;
};
exports.useGeolocation = useGeolocation;
//# sourceMappingURL=index.js.map