"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useGridLayout = void 0;
const react_1 = require("react");
const useResizeObserver_1 = require("../useResizeObserver");
const useNewRef_1 = require("../utils/useNewRef");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useGridLayout | useGridLayout} hook.
 */
const useGridLayout = (ref) => {
    const targetRef = (0, useNewRef_1.useNewRef)(ref);
    const [layoutValues, setLayoutValues] = (0, react_1.useState)({ rows: 0, columns: 0 });
    const updateLayoutValues = (0, react_1.useCallback)(() => {
        const container = targetRef.current;
        if (!container)
            return;
        const containerStyle = window.getComputedStyle(container);
        const rows = containerStyle.gridTemplateRows.trim().split(/\s+/).length;
        const columns = containerStyle.gridTemplateColumns.trim().split(/\s+/).length;
        setLayoutValues({ rows, columns });
    }, []);
    (0, react_1.useEffect)(updateLayoutValues, []);
    (0, useResizeObserver_1.useResizeObserver)({ handler: updateLayoutValues, ref: targetRef });
    return { ref: targetRef, ...layoutValues };
};
exports.useGridLayout = useGridLayout;
//# sourceMappingURL=index.js.map