"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useInView = void 0;
const react_1 = require("react");
const useIntersectionObserver_1 = require("../useIntersectionObserver");
const useNewRef_1 = require("../utils/useNewRef");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useInView | useInView} hook.
 */
const useInView = (args) => {
    const targetRef = (0, useNewRef_1.useNewRef)(args.ref);
    const [isInView, setIsInView] = (0, react_1.useState)(false);
    const handleIntersecting = (0, react_1.useCallback)((entries, observer) => {
        const { isIntersecting } = entries[0];
        if (isIntersecting && args.once)
            observer.unobserve(targetRef.current);
        setIsInView(isIntersecting);
    }, []);
    (0, useIntersectionObserver_1.useIntersectionObserver)({ ...args, ref: targetRef, handler: handleIntersecting });
    return { ref: targetRef, isInView };
};
exports.useInView = useInView;
//# sourceMappingURL=index.js.map