/// <reference types="react" />
export type IntersectionObserverOptions<T extends HTMLElement> = Omit<IntersectionObserverInit, 'root'> & {
    root?: () => Element | Document | null;
    ref?: React.RefObject<T> | null;
};
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useIntersectionObserver | useIntersectionObserver} hook.
 */
export declare const useIntersectionObserver: <T extends HTMLElement = HTMLDivElement>(args: IntersectionObserverOptions<T> & {
    handler: IntersectionObserverCallback;
}) => {
    ref: import("react").RefObject<T>;
    observerRef: import("react").MutableRefObject<IntersectionObserver | undefined>;
};
