"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useIntersectionObserver = void 0;
const react_1 = require("react");
const useNewRef_1 = require("../utils/useNewRef");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useIntersectionObserver | useIntersectionObserver} hook.
 */
const useIntersectionObserver = (args) => {
    const targetRef = (0, useNewRef_1.useNewRef)(args.ref);
    const observerRef = (0, react_1.useRef)();
    (0, react_1.useEffect)(() => {
        if (!targetRef.current)
            return;
        const root = args.root?.();
        observerRef.current = new IntersectionObserver(args.handler, { ...args, root });
        observerRef.current.observe(targetRef.current);
        return () => observerRef.current?.disconnect();
    }, [args.handler]);
    return { ref: targetRef, observerRef };
};
exports.useIntersectionObserver = useIntersectionObserver;
//# sourceMappingURL=index.js.map