/// <reference types="react" />
export type KeyboardEventCallback = (event: KeyboardEvent) => any;
export type KeysRecord = Record<string, KeyboardEventCallback>;
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useKeyboard | useKeyboard} hook.
 */
export declare const useKeyboard: <T extends EventTarget = Window>(args: {
    keys: KeysRecord;
    ref?: React.RefObject<T> | null;
    separator?: string;
}) => import("react").RefObject<T>;
