"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useMediaQuery = void 0;
const react_1 = require("react");
const useIsomorphicEffect_1 = require("../useIsomorphicEffect");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useMediaQuery | useMediaQuery} hook.
 */
const useMediaQuery = (query) => {
    const [matches, setMatches] = (0, react_1.useState)();
    (0, useIsomorphicEffect_1.useIsomorphicEffect)(() => {
        const mediaQueryList = window.matchMedia(query);
        const handleQueryChange = () => {
            setMatches(mediaQueryList.matches);
        };
        handleQueryChange();
        mediaQueryList.addEventListener('change', handleQueryChange);
        return () => mediaQueryList.removeEventListener('change', handleQueryChange);
    }, []);
    return matches;
};
exports.useMediaQuery = useMediaQuery;
//# sourceMappingURL=index.js.map