"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useMousePosition = void 0;
const react_1 = require("react");
const useEventListener_1 = require("../useEventListener");
const utils_1 = require("../utils");
const useNewRef_1 = require("../utils/useNewRef");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useMousePosition | useMousePosition} hook.
 */
const useMousePosition = (ref) => {
    const targetRef = (0, useNewRef_1.useNewRef)(ref);
    const [position, setPosition] = (0, react_1.useState)({ x: 0, y: 0 });
    const [isInside, setIsInside] = (0, react_1.useState)();
    const handleMouseMove = (0, react_1.useCallback)((event) => {
        setIsInside(event.type !== 'mouseleave');
        setPosition((0, utils_1.getPointerPosition)(event));
    }, []);
    (0, useEventListener_1.useEventListener)({
        event: ['mousemove', 'mouseenter', 'mouseleave'],
        handler: handleMouseMove,
        target: () => targetRef.current ?? window
    });
    return { ref: targetRef, isInside, ...position };
};
exports.useMousePosition = useMousePosition;
//# sourceMappingURL=index.js.map