/// <reference types="react" />
export type MutationObserverOptions<T extends HTMLElement> = MutationObserverInit & {
    ref?: React.RefObject<T> | null;
};
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useMutationObserver | useMutationObserver} hook.
 */
export declare const useMutationObserver: <T extends HTMLElement = HTMLDivElement>(args: MutationObserverOptions<T> & {
    handler: MutationCallback;
}) => {
    ref: import("react").RefObject<T>;
    observerRef: import("react").MutableRefObject<MutationObserver | undefined>;
};
