"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useMutationObserver = void 0;
const react_1 = require("react");
const useNewRef_1 = require("../utils/useNewRef");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useMutationObserver | useMutationObserver} hook.
 */
const useMutationObserver = (args) => {
    const targetRef = (0, useNewRef_1.useNewRef)(args.ref);
    const observerRef = (0, react_1.useRef)();
    (0, react_1.useEffect)(() => {
        if (!targetRef.current)
            return;
        observerRef.current = new MutationObserver(args.handler);
        observerRef.current.observe(targetRef.current, args);
        return () => observerRef.current?.disconnect();
    }, [args.handler]);
    return { ref: targetRef, observerRef };
};
exports.useMutationObserver = useMutationObserver;
//# sourceMappingURL=index.js.map