/**
 * @see https://developer.mozilla.org/en-US/docs/Web/API/NetworkInformation
 */
export type NetworkInformation = {
    type?: 'bluetooth' | 'cellular' | 'ethernet' | 'none' | 'wifi' | 'wimax' | 'other' | 'unknown';
    rtt?: number;
    downlink?: number;
    downlinkMax?: number;
    effectiveType?: 'slow-2g' | '2g' | '3g' | '4g';
    saveData?: boolean;
};
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useNetworkState | useNetworkState} hook.
 */
export declare const useNetworkState: () => NetworkInformation & {
    isOnline: boolean;
};
