"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useOrientation = void 0;
const react_1 = require("react");
const useIsomorphicEffect_1 = require("../useIsomorphicEffect");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useOrientation | useOrientation} hook.
 */
const useOrientation = () => {
    const [orientation, setOrientation] = (0, react_1.useState)();
    (0, useIsomorphicEffect_1.useIsomorphicEffect)(() => {
        const getOrientation = () => setOrientation(screen.orientation.type);
        getOrientation();
        window.addEventListener('orientationchange', getOrientation, { passive: true });
        return () => window.removeEventListener('orientationchange', getOrientation);
    }, []);
    return orientation;
};
exports.useOrientation = useOrientation;
//# sourceMappingURL=index.js.map