/// <reference types="react" />
export type PointerEventHandler = (event: PointerEvent, pointers: PointerEvent[]) => any;
export type PointerEventName<E = keyof HTMLElementEventMap> = E extends `pointer${string}` ? E : never;
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/usePointers | usePointers} hook.
 */
export declare const usePointers: <T extends HTMLElement = HTMLDivElement>(args: {
    handler: PointerEventHandler;
    ref?: React.RefObject<T> | null;
    capture?: boolean;
}) => import("react").RefObject<T>;
