"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRect = void 0;
const react_1 = require("react");
const useResizeObserver_1 = require("../useResizeObserver");
const useNewRef_1 = require("../utils/useNewRef");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useRect | useRect} hook.
 */
const useRect = (ref) => {
    const targetRef = (0, useNewRef_1.useNewRef)(ref);
    const [rect, setRect] = (0, react_1.useState)();
    const updateRect = (0, react_1.useCallback)(() => {
        setRect(targetRef.current.getBoundingClientRect());
    }, []);
    (0, useResizeObserver_1.useResizeObserver)({ ref: targetRef, handler: updateRect });
    return { ref: targetRef, rect };
};
exports.useRect = useRect;
//# sourceMappingURL=index.js.map