"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useResizeObserver = void 0;
const react_1 = require("react");
const useNewRef_1 = require("../utils/useNewRef");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useResizeObserver | useResizeObserver} hook.
 */
const useResizeObserver = (args) => {
    const targetRef = (0, useNewRef_1.useNewRef)(args.ref);
    const observer = (0, react_1.useRef)();
    (0, react_1.useEffect)(() => {
        if (!targetRef.current)
            return;
        observer.current = new ResizeObserver(args.handler);
        observer.current.observe(targetRef.current, args);
        return () => observer.current?.disconnect();
    }, [args.handler]);
    return { ref: targetRef, observer };
};
exports.useResizeObserver = useResizeObserver;
//# sourceMappingURL=index.js.map