/// <reference types="react" />
export type SwipeAction = {
    type: 'start' | 'moving' | 'end';
    deltaX: number;
    deltaY: number;
    initialX: number;
    initialY: number;
    event: PointerEvent;
};
export type SwipeActionHandler = (action: SwipeAction) => any;
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useSwiping | useSwiping} hook.
 */
export declare const useSwiping: <T extends HTMLElement>(args: {
    handler: SwipeActionHandler;
    ref?: React.RefObject<T> | null;
}) => import("react").RefObject<T>;
