"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useToggle = void 0;
const react_1 = require("react");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useToggle | useToggle} hook.
 */
const useToggle = (args) => {
    const [currentIndex, setCurrentIndex] = (0, react_1.useState)(() => {
        return Math.max(0, Math.min(args.startIndex ?? 0, args.values.length - 1));
    });
    const toggle = (0, react_1.useCallback)((value) => {
        if (!args.values.length)
            return;
        setCurrentIndex(index => {
            const currentValue = args.values[index];
            const newValue = value instanceof Function ? value(currentValue) : value;
            if (newValue !== undefined) {
                return args.values.includes(newValue) ? args.values.indexOf(newValue) : index;
            }
            return index === args.values.length - 1 ? 0 : index + 1;
        });
    }, [args.values]);
    return [args.values[currentIndex], toggle];
};
exports.useToggle = useToggle;
//# sourceMappingURL=index.js.map