"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useViewport = void 0;
const react_1 = require("react");
const useEventListener_1 = require("../useEventListener");
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useViewport | useViewport} hook.
 */
const useViewport = () => {
    const [viewport, setViewport] = (0, react_1.useState)({ width: 0, height: 0 });
    const updateViewport = (0, react_1.useCallback)(() => {
        setViewport({ width: window.innerWidth ?? 0, height: window.innerHeight ?? 0 });
    }, []);
    (0, useEventListener_1.useEventListener)({
        event: 'resize',
        handler: updateViewport,
        target: () => {
            updateViewport();
            return window;
        },
        passive: true
    });
    return viewport;
};
exports.useViewport = useViewport;
//# sourceMappingURL=index.js.map