export type WorkerHandler = (message: {
    data?: any;
    error?: unknown;
}) => any;
/**
 * @see {@link https://malkiii.github.io/react-pre-hooks/docs/hooks/useWorker | useWorker} hook.
 */
export declare const useWorker: (args: WorkerOptions & {
    script: string | (() => any | Promise<any>);
    handler: WorkerHandler;
}) => {
    isLoading: boolean;
    postMessage<M extends unknown>(message: M, options?: StructuredSerializeOptions): void;
    terminate(): void;
};
